SystemOrganization addCategory: #'Seaside-Tests-Session'!

WARegistryTest subclass: #WAApplicationEncodingFallbackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WAApplicationEncodingFallbackTest methodsFor: 'private' stamp: 'pmm 5/26/2010 21:26'!
newHandler
	^ WAApplication new
		preferenceAt: #charSet put: 'utf-16';
		yourself! !

!WAApplicationEncodingFallbackTest methodsFor: 'tests' stamp: 'pmm 5/26/2010 21:28'!
testContentType
	self assert: handler contentType = ('text/html' seasideMimeType
		charset: 'utf-16';
		yourself)! !

WARegistryTest subclass: #WAApplicationEncodingFromCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WAApplicationEncodingFromCodecTest methodsFor: 'configuration' stamp: 'pmm 5/26/2010 21:29'!
createCodec
	^ GRCodec forEncoding: 'iso-8859-1'! !

!WAApplicationEncodingFromCodecTest methodsFor: 'private' stamp: 'pmm 5/26/2010 21:30'!
newHandler
	^ WAApplication new
		preferenceAt: #charSet put: 'utf-16';
		yourself! !

!WAApplicationEncodingFromCodecTest methodsFor: 'tests' stamp: 'pmm 5/26/2010 21:29'!
testContentType
	self assert: handler contentType = ('text/html' seasideMimeType
		charset: 'iso-8859-1';
		yourself)! !

WARegistryTest subclass: #WAApplicationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WAApplicationTest class methodsFor: 'testing' stamp: 'jf 1/29/2009 20:59'!
shouldInheritSelectors
	^ true! !

!WAApplicationTest methodsFor: 'private' stamp: 'jf 9/24/2009 00:00'!
newHandler
	^ WAApplication new! !

!WAApplicationTest methodsFor: 'running' stamp: 'pmm 8/31/2009 14:05'!
requestWithMethod: aString
	^ WARequest
		method: aString
		uri: '/app/oneo'! !

!WAApplicationTest methodsFor: 'tests' stamp: 'jf 1/29/2009 21:19'!
testNotImplemented
	| context request |
	#('OPTIONS' 'HEAD' 'PUT' 'DELETE' 'TRACE' 'CONNECT') do: [ :each |
		request := self requestWithMethod: each.
		context := WARequestContext request: request response: WABufferedResponse new.
		[ handler handle: context ]
			on: WAResponseNotification
			do: [ :notification | ].
		self assert: context response status = 501 ].
	
	#('GET' 'POST') do: [ :each |
		request := self requestWithMethod: each.
		context := WARequestContext request: request response: WABufferedResponse new.
		[ handler handle: context ]
			on: WAResponseNotification
			do: [ :notification | ].
		self assert: context response status ~= 501 ]! !

!WAApplicationTest methodsFor: 'tests' stamp: 'lr 9/8/2009 19:46'!
testPathConsumption
	| context request |
	request := self requestWithMethod: 'GET'.
	context := WARequestContext request: request response: WABufferedResponse new.
	context consumer next.
	self assert: context consumer peek = 'oneo'.
	[ handler handle: context ]
		on: WAResponseNotification
		do: [ :notification | ].
	self assert: context consumer peek = 'oneo'! !

!WAApplicationTest methodsFor: 'tests' stamp: 'pmm 6/20/2011 21:11'!
testPreFetchIsForbidden
	| context request |

	request := self requestWithMethod: 'GET'.
	request headers at: 'x-moz' put: 'prefetch'. "turn it into a prefetch request"
	self assert: request isPrefetch.
		
	context := WARequestContext request: request response: WABufferedResponse new.
	[ handler handle: context ]
		on: WAResponseNotification
		do: [ :notification | "ignore" ].
	self assert: context response status = WAResponse statusForbidden.! !

WARegistryTest subclass: #WASessionCookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WASessionCookieTest class methodsFor: 'testing' stamp: 'pmm 8/12/2010 23:23'!
shouldInheritSelectors
	^ true! !

!WASessionCookieTest methodsFor: 'private' stamp: 'pmm 8/12/2010 23:45'!
newHandler
	^ WAApplication new
		preferenceAt: #useCookies put: true;
		preferenceAt: #serverHostname put: 'www.seaside.st';
		yourself! !

!WASessionCookieTest methodsFor: 'running' stamp: 'pmm 8/12/2010 23:23'!
requestWithMethod: aString
	^ WARequest
		method: aString
		uri: '/'! !

!WASessionCookieTest methodsFor: 'tests' stamp: 'pmm 8/12/2010 23:54'!
testDeleteSessionCookieDomain
	| context request response cookie |
	request := self requestWithMethod: 'GET'.
	request setCookies: (Array with: (WARequestCookie key: '_s' value: 'goner')).
	response := WABufferedResponse new.
	context := WARequestContext request: request response: response.
	[ handler handle: context ]
		on: WAResponseNotification
		do: [ :notification | ].
	self assert: response status = 302. "session gone"
	self assert: response cookies size = 1.
	cookie := response cookies first.
	self assert: cookie domain = 'www.seaside.st'! !

!WASessionCookieTest methodsFor: 'tests' stamp: 'pmm 8/12/2010 23:47'!
testNewSessionCookieDomain
	| context request response cookie |
	request := self requestWithMethod: 'GET'.
	response := WABufferedResponse new.
	context := WARequestContext request: request response: response.
	[ handler handle: context ]
		on: WAResponseNotification
		do: [ :notification | ].
	self assert: response cookies size = 1.
	cookie := response cookies first.
	self assert: cookie domain = 'www.seaside.st'! !

!WASessionCookieTest methodsFor: 'tests' stamp: 'lr 8/22/2010 15:30'!
testUrlFor
	| context request response documentHandler url |
	request := self requestWithMethod: 'GET'.
	request setCookies: (Array with: (WARequestCookie key: '_s' value: 'sessionid')).
	response := WABufferedResponse new.
	documentHandler := (WADocumentHandler
		document: 'body: {color: red}'
		mimeType: WAMimeType textCss
		fileName: nil).
	
	context := WARequestContext request: request response: response.
	url := WACurrentRequestContext
		use: context
		during: [ handler register: documentHandler;
			urlFor: documentHandler ].
	self assert: (url queryFields includesKey: '_s').
	request url addField: '_s' value: (url queryFields at: '_s').
		
	[  handler handle: context ]
		on: WAResponseNotification
		do: [ :notification | ].
		
	self assert: response status = 200.
	self assert: (response cookies isEmpty)! !

WASession subclass: #WATestSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WATestSession methodsFor: 'handling' stamp: 'lr 2/16/2010 20:53'!
start
	(self requestContext response)
		nextPutAll: 'start: ';
		nextPutAll: self key! !

TestCase subclass: #WACurrentSessionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WACurrentSessionTest commentStamp: 'pmm 3/29/2008 12:34' prior: 0!
A WACurrentSessionTest is to make sure

WACurrentSession value

works as in Seaside 2.9 as it did in earlier versions.
!

!WACurrentSessionTest methodsFor: 'tests' stamp: 'NickAger 7/11/2011 21:57'!
testWithValue
	| session context |
	session := WASession new.
	context := WARequestContext request: nil response: nil.
	context
		push: session
		during: [ self assert: WACurrentSession value = session ]! !

!WACurrentSessionTest methodsFor: 'tests' stamp: 'jf 2/3/2009 13:35'!
testWithoutContext
	self assert: WACurrentSession value isNil! !

!WACurrentSessionTest methodsFor: 'tests' stamp: 'jf 2/3/2009 14:48'!
testWithoutSession
	| context |
	context := WARequestContext request: nil response: nil.
	WACurrentRequestContext
		use: context
		during: [ self assert: WACurrentSession value isNil ]! !

!GRPackage class methodsFor: '*seaside-tests-session' stamp: 'lr 2/17/2010 15:14'!
seasideTestsSession
	^ self new
		name: 'Seaside-Tests-Session';
		description: 'Unit tests for the package Seaside-Session.';
		addDependency: 'Seaside-Session';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !

WARegistryKeyHandlingTest subclass: #WAApplicationKeyHandlingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WAApplicationKeyHandlingTest class methodsFor: 'testing' stamp: 'jf 1/30/2009 13:30'!
shouldInheritSelectors
	^ true! !

!WAApplicationKeyHandlingTest methodsFor: 'private' stamp: 'jok 3/22/2010 11:53'!
assertDefault: aResponse
	"Instead of returning 404 on a default request as WARegistry does, WAApplication creates a new
	Session and dispatches to it."
	self assert: registry cache size = (registrySize + 1).
	self assert: aResponse status = 200.
	self assert: (aResponse contents beginsWithSubCollection: 'start:')! !

!WAApplicationKeyHandlingTest methodsFor: 'private' stamp: 'pmm 9/5/2009 12:23'!
createRegistry
	^ WADispatcher new
		register: (WAApplication new
			preferenceAt: #sessionClass put: WATestSession;
			yourself)
		at: self registryName! !

!WAApplicationKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 13:16'!
fieldName
	^ '_s'! !

!WAApplicationKeyHandlingTest methodsFor: 'private' stamp: 'pmm 8/13/2010 13:59'!
registerNewHandler
	^ registry register: WATestNoopSessionHandler new! !

!WAApplicationKeyHandlingTest methodsFor: 'tests' stamp: 'jf 1/30/2009 16:15'!
testNoKey
	"There is no URL field and no cookie. This is a new request to the Registry.
	
	Instead of returning a 404, like WARegistry does, WAApplication creates a new WASession
	and also adds the cookie."
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: nil cookieKey: nil.
	response := self dispatch: context to: registry.
	
	self assertCookieAddition: response.
	self assert: ((registry cache at: response cookies first value) isKindOf: WASession).
	self assertDefault: response! !

WAContextTest subclass: #WAInteractionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Session'!

!WAInteractionTest commentStamp: 'pmm 2/18/2011 22:51' prior: 0!
The purpose of WAInteractionTest is to provide a fully initialized WContext all the neccsary objects are are normally there in a Seaside application like request, response, dispatcher application, session and so forth.!

!WAInteractionTest methodsFor: 'accessing' stamp: 'jf 1/21/2009 12:19'!
application
	^self requestContext application! !

!WAInteractionTest methodsFor: 'configuration' stamp: 'jf 9/30/2009 01:43'!
createHandlers
	| dispatcher application session root |
	root := WADispatcher new.
	dispatcher := root register: WADispatcher new at: 'rails'.
	application := dispatcher register: WAApplication new at: 'homepage'.
	session := WASession new.
	application register: session.

	^super createHandlers, (Array with: root with: dispatcher with: application with: session)! !

!WAInteractionTest methodsFor: 'accessing' stamp: 'jf 1/21/2009 12:19'!
session
	^self requestContext session! !

!WAInteractionTest methodsFor: 'tests' stamp: 'jf 2/6/2010 00:41'!
testDeleteNetscapeCookie
	| requestCookie responseCookies responseCookie |
	self application preferenceAt: #serverPath put: '/en/private_kunden/wealth_management'.
	requestCookie := WARequestCookie key: 'password' value: 'sex'.
	self requestContextWithUrl: '/' cookies: (Array with: requestCookie).
	self requestContext response deleteCookie: requestCookie.
	
	responseCookies := self requestContext response cookies.
	self assert: responseCookies size = 1.
	responseCookie := responseCookies any.
	
	self assert: (responseCookie isKindOf: WACookie).
	self assert: responseCookie value = ''.
	self assert: responseCookie path = self application url pathString! !

!WAInteractionTest methodsFor: 'tests' stamp: 'jf 2/6/2010 00:41'!
testDeleteRfc2965Cookie
	| requestCookie responseCookies responseCookie |
	requestCookie := (WARequestCookie key: 'password' value: 'sex')
		path: '/en/private_kunden/wealth_management';
		version: 1;
		yourself.
	self requestContextWithUrl: '/' cookies: (Array with: requestCookie).
	self requestContext response deleteCookie: requestCookie.
	
	responseCookies := self requestContext response cookies.
	self assert: responseCookies size = 1.
	responseCookie := responseCookies any.
	
	self assert: (responseCookie isKindOf: WACookie).
	self assert: responseCookie value = ''.
	self assert: responseCookie path = '/en/private_kunden/wealth_management'! !

!WAInteractionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 01:15'!
testNewCookie
	| cookie |
	cookie := self requestContext newCookie.
	self assert: cookie path = self application url pathString.
	self assert: cookie ports isNil.
	self assert: cookie httpOnly.
	self deny: cookie secure.
	self assert: cookie domain isNil.
	
	self application preferenceAt: #serverPath put: '/en/private_kunden/wealth_management'.
	cookie := self requestContext newCookie.
	self assert: cookie path = '/en/private_kunden/wealth_management'.
	self assert: cookie ports isNil.
	self assert: cookie httpOnly.
	self deny: cookie secure.
	self assert: cookie domain isNil.
	
	self application preferenceAt: #serverPort put: 8080.
	self application preferenceAt: #serverProtocol put: 'https'.
	self application preferenceAt: #serverHostname put: 'www.lgt.com'.
	cookie := self requestContext newCookie.
	self assert: cookie path = '/en/private_kunden/wealth_management'.
	self deny: cookie ports isNil.
	self assert: cookie ports size = 1.
	self assert: cookie ports first = 8080.
	self assert: cookie httpOnly.
	self assert: cookie secure.
	self assert: cookie domain = 'www.lgt.com'! !
